%ctls
%bin		21
%conds
%crefall
%depth		1
%incl
%linum		5
%list
masm
multerrs
noemul
nojumps
nolocals
%nomacs
nomasm51
%notrunc
p8086
%pagesize	74, 112
%pcnt		4
radix		10
.seq
smart
%syms
%tabsize	8
%text		70
warn

;---------------------------------------------------------------------
;
;	_SN.ASM
;
;	Version 1.00
;
;	Two functions used by _SN.C:
;
;	READ_BOOT_SECTOR	- reads  boot sector from disk
;	WRITE_BOOT_SECTOR	- writes boot sector to   disk
;
;	Steve Grant
;	Jersey City, NJ
;	September 5, 1991
;
;---------------------------------------------------------------------

public	_read_boot_sector
public	_write_boot_sector

;---------------------------------------------------------------------

.model	small

.code

;---------------------------------------------------------------------

_read_boot_sector	proc

; On entry:
;
;		BP
;	SP =>	near return address
;		drive number (0=A, 1=B, etc.)
;		offset  of disk buffer
;
; On exit:
;
;	AX	= function result
;		0000	- function successful
;		other	- error result as returned by INT 25H
;	buffer	= filled in with data from disk boot sector

ARG	drive	: byte : 2, \
	buffer	: ptr

	push	bp
	mov	bp, sp

	mov	al, drive
	xor	dx, dx
	mov	cx, 1
	mov	bx, buffer
	push	bp
	push	di
	push	si
	int	25H
	inc	sp			; fix broken stack
	inc	sp
	pop	si
	pop	di
	pop	bp
	jc	_r_1

	xor	ax, ax

_r_1:
	mov	sp, bp
	pop	bp
	ret

_read_boot_sector	endp

;---------------------------------------------------------------------

_write_boot_sector	proc near

; On entry:
;
;		BP
;	SP =>	near return address
;		drive number (0=A, 1=B, etc.)
;		offset  of disk buffer
;
; On exit:
;
;	AX	= function result
;		0000	- function successful
;		other	- error result as returned by INT 26H

ARG	drive	: byte : 2, \
	buffer	: ptr

	push	bp
	mov	bp, sp

	mov	al, drive
	xor	dx, dx
	mov	cx, 1
	mov	bx, buffer
	push	bp
	push	di
	push	si
	int	26H
	inc	sp			; fix broken stack
	inc	sp
	pop	si
	pop	di
	pop	bp
	jc	_w_1

	xor	ax, ax

_w_1:
	mov	sp, bp
	pop	bp
	ret

_write_boot_sector	endp

;---------------------------------------------------------------------

	end
